SystemOrganization addCategory: #'Xtreams-Http'!

Object subclass: #XTChunkBuffer
	instanceVariableNames: 'prefixSize suffixSize bytes position'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Http'!

!XTChunkBuffer class methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 21:51'!
new: anInteger
	^ self basicNew initializeWithSize: anInteger! !

!XTChunkBuffer methodsFor: 'accessing' stamp: 'cwp 5/2/2011 22:23'!
available
	^ bytes size - suffixSize - position + 1! !

!XTChunkBuffer methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 23:06'!
clear
	| header |
	position := prefixSize + 1.
	header := self size printStringBase: 16.
	bytes replaceFrom: 1 to: header size with: header.
	bytes at: header size + 1 put: 13.
	bytes at: header size + 2 put: 10.
	bytes at: bytes size - 1 put: 13.
	bytes at: bytes size put: 10.
! !

!XTChunkBuffer methodsFor: 'as yet unclassified' stamp: 'cwp 5/5/2011 00:42'!
close: aWriteStream
	| chunk start |
	chunk := #[48 13 10 13 10].
	start := self prepareFlush.
	self available >= chunk size
		ifTrue:  
			[bytes replaceFrom: position to: position + 4 with: chunk.
			position := position + chunk size.
			aWriteStream write: position - start from: bytes at: start]
		ifFalse:  
			[aWriteStream
				write: position - start from: bytes at: start;
				write: chunk]! !

!XTChunkBuffer methodsFor: 'as yet unclassified' stamp: 'cwp 5/4/2011 13:59'!
flush: aWriteStream
	| start |
	start := self prepareFlush.
	aWriteStream write: position - start from: bytes at: start! !

!XTChunkBuffer methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 23:36'!
flushIfFull: aWriteStream
	self isFull ifTrue:
		[aWriteStream write: bytes.
		position := prefixSize + 1]! !

!XTChunkBuffer methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 22:56'!
initializeWithSize: anInteger
	prefixSize := (anInteger numberOfDigitsInBase: 16) + 2.
	suffixSize := 2.
	bytes := ByteArray new: prefixSize + anInteger + suffixSize.
	self clear! !

!XTChunkBuffer methodsFor: 'testing' stamp: 'cwp 5/2/2011 22:27'!
isFull
	^ self available = 0! !

!XTChunkBuffer methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 23:21'!
prepareFlush
	| header start |
	header := position - prefixSize - 1 printStringBase: 16.
	start := prefixSize - header size - 1.
	bytes
		replaceFrom: start
		to: prefixSize - 2
		with: header
		startingAt: 1.
	self put: 13.
	self put: 10.
	^ start! !

!XTChunkBuffer methodsFor: 'as yet unclassified' stamp: 'cwp 5/2/2011 22:46'!
put: aByte
	bytes at: position put: aByte.
	position := position + 1! !

!XTChunkBuffer methodsFor: 'accessing' stamp: 'cwp 5/2/2011 22:54'!
size
	^ bytes size - prefixSize - suffixSize! !

!XTChunkBuffer methodsFor: 'writing' stamp: 'cwp 5/2/2011 22:33'!
streamingWriteInto: aStream
	! !

!XTChunkBuffer methodsFor: 'accessing' stamp: 'cwp 5/2/2011 22:32'!
truncate
	bytes at: position put: 13.
	bytes at: position put: 10.! !

!XTChunkBuffer methodsFor: 'writing' stamp: 'cwp 5/2/2011 23:41'!
write: count from: aByteArray at: start 
	| size |
	size := count min: self available.
	bytes replaceFrom: position to: position + size - 1 with: aByteArray startingAt: start.
	position := position + size.
	^ size	! !

XTWriteStream subclass: #XTChunkingWriteStream
	instanceVariableNames: 'buffer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Http'!

!XTChunkingWriteStream methodsFor: 'public' stamp: 'cwp 5/2/2011 22:59'!
bufferSize: anInteger
	buffer := XTChunkBuffer new: anInteger! !

!XTChunkingWriteStream methodsFor: 'public' stamp: 'cwp 5/2/2011 23:19'!
close
	buffer close: destination.
	destination close.! !

!XTChunkingWriteStream methodsFor: 'as yet unclassified' stamp: 'cwp 3/17/2011 12:36'!
contentsSpecies
	^ destination contentsSpecies! !

!XTChunkingWriteStream methodsFor: 'public' stamp: 'cwp 5/2/2011 23:00'!
flush
	buffer flush: destination! !

!XTChunkingWriteStream methodsFor: 'public' stamp: 'cwp 5/5/2011 00:36'!
on: aDestination
	super on: aDestination.
	self bufferSize: 1024! !

!XTChunkingWriteStream methodsFor: 'public' stamp: 'cwp 5/2/2011 22:16'!
put: aByte
	buffer put: aByte.
	buffer flushIfFull: destination! !

!XTChunkingWriteStream methodsFor: 'public' stamp: 'cwp 5/2/2011 22:25'!
write: count from: bytes at: start
	| limit written position |
	limit := start + count.
	position := start.
	[position < limit] whileTrue:
		[written := buffer write: limit - position from: bytes at: position.
		position := position + written.
		buffer flushIfFull: destination]! !

!XTWriteStream methodsFor: '*Xtreams-Http-transforming' stamp: 'cwp 3/16/2011 00:43'!
chunking
	^ XTChunkingWriteStream on: self.! !

!XTWriteStream methodsFor: '*Xtreams-Http-transforming' stamp: 'cwp 9/11/2011 14:46'!
chunking: anInteger
	^ (XTChunkingWriteStream on: self)
		bufferSize: anInteger! !

XTReadStream subclass: #XTChunkingReadStream
	instanceVariableNames: 'buffer position limit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Xtreams-Http'!

!XTChunkingReadStream methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 15:15'!
contentsSpecies 
	^ ByteArray ! !

!XTChunkingReadStream methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 15:50'!
on: aReadStream
	super on: aReadStream.
	buffer := #[].
	position := 1.
	limit := 0.
	! !

!XTChunkingReadStream methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 16:09'!
read: total into: aCollection at: startIndex
	| amount available count index |
	count := 0.
	index := startIndex.
	[count < total] whileTrue:
		[position > limit ifTrue: [self readChunk].
		available := limit - position + 1.
		available = 0 ifTrue: [(Incomplete on: aCollection count: count at: index) signal].
		amount := total - count min: available.
		aCollection replaceFrom: index to: index + amount - 1 with: buffer startingAt: position.
		position := position + amount.
		count := count + amount.
		index := index + amount]
	! !

!XTChunkingReadStream methodsFor: 'as yet unclassified' stamp: 'cwp 9/12/2011 15:58'!
readChunk
	| count |
	count := (source ending: #[13 10]) rest asString asInteger.
	count > buffer size ifTrue: [buffer := ByteArray new: count].
	source read: count into: buffer at: 1.
	source ++ 2.	"skip the crlf after the chunk"
	position := 1.
	limit := count.! !

!XTReadStream methodsFor: '*Xtreams-Http' stamp: 'cwp 9/11/2011 16:02'!
chunking
	^ XTChunkingReadStream on: self! !
